Bug 1451298 - Review Request: vertex-theme - Vertex is a theme for GTK 3, GTK 2, Gnome-Shell and Cinnamon
Summary: Review Request: vertex-theme - Vertex is a theme for GTK 3, GTK 2, Gnome-Shel...
Keywords:
Status: POST
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Zbigniew Jędrzejewski-Szmek
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-05-16 10:59 UTC by Thanos Apostolou
Modified: 2018-09-30 22:46 UTC (History)
7 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
Type: ---
zbyszek: fedora-review+


Attachments (Terms of Use)

Description Thanos Apostolou 2017-05-16 10:59:48 UTC
Spec URL:
http://copr-dist-git.fedorainfracloud.org/cgit/thanosapostolou/vertex-theme/vertex-theme.git/tree/vertex-theme.spec

SRPM URL:
https://copr-be.cloud.fedoraproject.org/results/thanosapostolou/vertex-theme/fedora-rawhide-x86_64/00552099-vertex-theme/vertex-theme-20170128-1.fc27.src.rpm

Description:
Vertex is a theme for GTK 3, GTK 2, Gnome-Shell and Cinnamon. It supports GTK 3 and GTK 2 based desktop environments like Gnome, Cinnamon, Mate, XFCE, Budgie, Pantheon, etc. Themes for the Browsers Chrome/Chromium and Firefox are included, too. The theme comes with three variants to choose from. The default variant with dark header-bars, a light variant, and a dark variant.

Fedora Account System Username: thanosapostolou

This is my first package so I am seeking a sponsor. I built it originally in copr (https://copr.fedorainfracloud.org/coprs/thanosapostolou/vertex-theme/package/vertex-theme/) but I believe that this package is a good fit for fedora and it would be great if it was included in the official repositories.

Comment 1 Artur Iwicki 2017-05-18 17:04:26 UTC
I am not a packager, so this is not an official review.

You should include the COPYING file in the RPM, as detailed here:
https://fedoraproject.org/wiki/Packaging:LicensingGuidelines#License_Text

In the %files section, the directories are unowned. You have specified file ownership, but not directory ownership.
https://fedoraproject.org/wiki/Packaging:UnownedDirectories#Wildcarding_Files_inside_a_Created_Directory

As a minor note, you do not need to use -n with %setup, as %{name}-%{version} is the default directory name assumed by %setup.

Comment 2 Thanos Apostolou 2017-05-19 10:07:34 UTC
Thx Iwicki Artur. Fedora has really long documentation. I keep reading it, but I still have a lot to learn :P

I upgraded the package.

SPEC URL (same as before):
http://copr-dist-git.fedorainfracloud.org/cgit/thanosapostolou/vertex-theme/vertex-theme.git/tree/vertex-theme.spec

SRPM URL:
https://copr-be.cloud.fedoraproject.org/results/thanosapostolou/vertex-theme/fedora-rawhide-x86_64/00553988-vertex-theme/vertex-theme-20170128-2.fc27.src.rpm

Comment 3 Zbigniew Jędrzejewski-Szmek 2017-05-26 16:19:42 UTC
Some trivialities up front:
- you should link to the plain spec file and src.rpm, so that tools like fedora-review can download the package. So link to http://copr-dist-git.fedorainfracloud.org/cgit/thanosapostolou/vertex-theme/vertex-theme.git/plain/vertex-theme.spec instead.

- The %description should be wrapped to <= 80 columns. About 72 is good.

- it looks like you have mixed tab and spaced indentation. Nowadays spaces are standard, so I'd recommend just using that. But either way, you should just stick to one style of indentation, so everything lines up no matter how many spaces the tab is interpreted as (if you use tabs).

- You should drop Group tag [https://fedoraproject.org/wiki/Packaging:Guidelines#Tags_and_Sections].

- You should remove the package name from the Summary — a listing will usually show the package name anyway, and space is at premium.

Looks good apart from those (relatively minor) issues.

--

To move things along, you will want to do some reviews of other packages. It's the best way to learn how other people do packaging, and the different tricks used for different languages and package types.

You should start with setting up a mock environment and running fedora-review on some packages. (I assume you haven't done that on this package, c.f. the first para of my comment ;)). ATM I cannot find good instructions how to install and configure mock, but essentially 'sudo dnf install mock && sudo usermod -a -G mock myusername'. You can then test building your srpm in mock.

Once that's working, you can run fedora-review on this bug ('fedora-review -b 1451298'), and others. I'd suggest reviewing #1421506.

Comment 4 Thanos Apostolou 2017-05-26 21:02:04 UTC
Ok, I fixed those issues.

Spec URL: http://copr-dist-git.fedorainfracloud.org/cgit/thanosapostolou/vertex-theme/vertex-theme.git/plain/vertex-theme.spec

SRPM URL: https://copr-be.cloud.fedoraproject.org/results/thanosapostolou/vertex-theme/fedora-rawhide-x86_64/00557222-vertex-theme/vertex-theme-20170128-3.fc27.src.rpm

I can successfully build it with command "mock -r fedora-rawhide-x86_64 --rebuild vertex-theme-20170128-3.fc26.src.rpm". I have successfully built it and upload it at copr too. However, I get an error "mock build failed" when I try fedora-review with command "fedora-review -m fedora-rawhide-x86_64 -n vertex-theme". Here is the review.txt: https://pastebin.com/qqGwL5nj. The spec errors are fixed, so I don't know what I'm doing wrong.

Comment 5 Zbigniew Jędrzejewski-Szmek 2017-05-26 23:24:49 UTC
That's not really an error. The only thing that failed is installation of the built packages in mock. This is most likely because you used '-n' and already had the packages installed. IIRC, you get this error in that case, and you can ignore it.

Comment 6 Jan Kalina 2017-06-01 09:03:24 UTC
Informal Package Review
=======================
summary:
- changelog in spec should contain authors of entries
- Require "filesystem" is unnecessary/redundant
- otherwise looks ok from me

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 3864 files have unknown license.
     Detailed output of licensecheck in /home/jkalina/review-vertex-
     theme/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[!]: Changelog in prescribed format: entries should contain author!
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[-]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[!]: Requires correct, justified where necessary: unnecessary dependency on "filesystem"
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Package should not use obsolete m4 macros
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: vertex-theme-20170128-3.fc27.noarch.rpm
          vertex-theme-20170128-3.fc27.src.rpm
2 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
1 packages and 0 specfiles checked; 0 errors, 0 warnings.



Requires
--------
vertex-theme (rpmlib, GLIBC filtered):
    filesystem
    gnome-themes-standard
    gtk-murrine-engine



Provides
--------
vertex-theme:
    vertex-theme



Source checksums
----------------
https://github.com/horst3180/vertex-theme/archive/20170128.tar.gz :
  CHECKSUM(SHA256) this package     : 1540657ff247bcdb9c49a740e4ddf305aecd4f3bebc93ca566fe74d319b7a620
  CHECKSUM(SHA256) upstream package : 1540657ff247bcdb9c49a740e4ddf305aecd4f3bebc93ca566fe74d319b7a620


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -u https://bugzilla.redhat.com/show_bug.cgi?id=1451298
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 7 Antonio T. (sagitter) 2017-06-01 19:59:51 UTC
@Thanos

Use macro as soon as possible:
http://copr-dist-git.fedorainfracloud.org/cgit/thanosapostolou/vertex-theme/vertex-theme.git/tree/vertex-theme.spec#n31

./autogen.sh --prefix=/usr --> ./autogen.sh --prefix=%{_prefix}

Including an appdata file may be a good idea: http://fedoraproject.org/wiki/Packaging:Guidelines#AppData_files

Comment 8 Antonio T. (sagitter) 2017-06-01 20:03:15 UTC
(In reply to Antonio Trande from comment #7)
> @Thanos
> 
> Use macro as soon as possible:
> http://copr-dist-git.fedorainfracloud.org/cgit/thanosapostolou/vertex-theme/
> vertex-theme.git/tree/vertex-theme.spec#n31
> 


Use macros as much as possible, i meant. :)

Comment 9 Thanos Apostolou 2017-07-14 12:24:14 UTC
Spec URL: http://copr-dist-git.fedorainfracloud.org/cgit/thanosapostolou/vertex-theme/vertex-theme.git/plain/vertex-theme.spec

SRPM URL: https://copr-be.cloud.fedoraproject.org/results/thanosapostolou/vertex-theme/fedora-rawhide-x86_64/00579400-vertex-theme/vertex-theme-20170128-5.fc27.src.rpm

Sorry for delay, I was quite busy the last month. I changed the --prefix=%{_prefix} and I added my name to changelog. Can you tell me what do I need to do now, in order to proceed?

Comment 10 Zbigniew Jędrzejewski-Szmek 2017-07-15 04:24:20 UTC
> Requires:       filesystem
Not needed, it's implied (as Jan said above).

Sorry to be such a stickler for this, ... but ... the %description is still terribly indented. Why can't you just press alt-q in emacs (or the equivalent in your editor of choice) to wrap the text automatically?

OK, the package is good.

> Can you tell me what do I need to do now, in order to proceed?

I'll sponsor you. Please review some other packages (two or three). See the second part of my comment #c3 (but note that I pasted the wrong bug number there, #1421506 is a tough review for a compiler, so not something for a first review). Pick something from http://fedoraproject.org/PackageReviewStatus/NEW.html that you interests you, once you get the packager bit you can finalize the review.

Comment 11 Thanos Apostolou 2017-07-20 11:55:08 UTC
I'm really sorry about this, but I gave it a good thought and I don't have enough available time in order to join the packagers effort. So, I'm dropping this.

Maybe I try again the next summer, if I have more time then.

Again sorry about the time you lost trying to guide me. Please close this package request.

Comment 12 Zbigniew Jędrzejewski-Szmek 2017-07-20 12:45:12 UTC
OK. Too bad, but that happens. Maybe you or somebody else can pick this up in the future. The package is OK, so any existing packager can almost immediately build it.


Note You need to log in before you can comment on or make changes to this bug.